if (!$BBGB)
{
	$remapDivision[$remapCount] = "Boxbuild";
	$remapName[$remapCount] = "Open GUI";
	$remapCmd[$remapCount] = "BB_OG";
	$remapCount++;
	$BBGB = true;
}

function BB_OG(%val)
{
	if(%val)
	{
		canvas.pushDialog(BoxListGui);
	}
}

function BoxListGui::onWake(%this)
{
	BB_PWBox.setVisible(0);
	BB_PWBox.setValue("");
	BB_JoinButton.setVisible(0);
	BB_CloseMP(%id);
	BB_BoxList.clear();
	commandToServer('getBoxList');
}

function BoxListGui::onSleep(%this)
{
	BB_PWBox.setVisible(0);
	BB_PWBox.setValue("");
	BB_JoinButton.setVisible(0);
	BB_CloseMP(%id);
}

function BB_SelectBox(%id)
{
	if($BB_BoxPassworded[%id])
	{
		BB_PWBox.setVisible(1);
		BB_PWBox.setValue("");
		BB_JoinButton.setVisible(1);
		$BB_Passworded=1;
	}
	else
	{
		BB_PWBox.setVisible(0);
		BB_PWBox.setValue("");
		BB_JoinButton.setVisible(1);
		$BB_Passworded=0;
	}
	if($BB_MyBox[%id])
	{
		BB_OpenMP(%id);
	}
	else
	{
		BB_CloseMP(%id);
	}
}

function BB_OpenMP(%id)
{
	BB_BoxMan.setVisible(1);
	BB_BoxAdm.setVisible(1);
	BB_BoxWnd.resize(getWord(BB_BoxWnd.getPosition(),0),getWord(BB_BoxWnd.getPosition(),1),425,400);
	BB_RefreshPlayerlist(%id);
}

function BB_CloseMP(%id)
{
	BB_BoxMan.setVisible(0);
	BB_BoxAdm.setVisible(0);
	BB_BoxWnd.resize(getWord(BB_BoxWnd.getPosition(),0),getWord(BB_BoxWnd.getPosition(),1),220,400);
}

function BB_RefreshPlayerlist(%id)
{
	if(%id$="")
	{
		%id=$BB_LastPlayerRefresh;
	}
	else
	{
		$BB_LastPlayerRefresh=%id;
	}
	BB_PlayerList.clear();
	commandToServer('getBoxPlayers',%id);
}

function BB_KickPlayer(%id)
{
	commandToServer('boxKick',$BB_LastPlayerRefresh,$BB_PlayerName[%id]);
	BB_RefreshPlayerList();
}

function BB_BanPlayer(%id)
{
	commandToServer('boxBanID',$BB_LastPlayerRefresh,$BB_PlayerBLID[%id],1);
	commandToServer('boxKick',$BB_LastPlayerRefresh,$BB_PlayerName[%id]);
	BB_RefreshPlayerList();
}

function BB_JoinBox(%id,%pw)
{
	commandToServer('moveToBox',%id,(($BB_Passworded)?%pw:""));
}

function BB_OpenBanGui()
{
	$BB_BanlistBox=$BB_LastPlayerRefresh;
	canvas.pushDialog(BoxBanlistGui);
}

function clientCmdBB_ReceiveBox(%id,%flds,%mine)
{
	BB_BoxList.addRow(%id,%id TAB %flds);
	$BB_BoxPassworded[%id]=getField(%flds,0);
	$BB_MyBox[%id]=%mine;
}

function clientCmdBB_ReceivePlayers(%id,%boxid,%name,%blid)
{
	BB_PlayerList.addRow(%id,%name);
	$BB_PlayerName[%id]=%name;
	$BB_PlayerBox[%id]=%boxid;
	$BB_PlayerBLID[%id]=%blid;
}

function BB_SelectPlayer(%id)
{}

//BanManager
function BoxBanlistGui::onWake(%this)
{
	BB_refreshBanlist($BB_BanlistBox);
}

function BB_refreshBanlist(%id)
{
	BB_Banlist.clear();
	commandToServer('getBoxBanlist',%id);
}

function BB_BanID(%blid)
{
	commandToServer('boxBanID',$BB_BanlistBox,%blid,1);
	BB_refreshBanlist($BB_BanlistBox);
}

function BB_UnBanID(%blid)
{
	commandToServer('boxBanID',$BB_BanlistBox,%blid,-1);
	BB_refreshBanlist($BB_BanlistBox);
}

function clientCmdBB_ReceiveBanlist(%blid)
{
	if(%blid$="") {return;}
	BB_Banlist.addRow(%blid,%blid);
}

//Box Settings
function BB_OpenSettings()
{
	$BB_SettingBox=$BB_LastPlayerRefresh;
	canvas.pushDialog(BoxSettingsGui);
}

function BoxSettingsGui::onWake(%this)
{
	BB_SetName.setValue("");
	BB_SetMsg.setValue("");
	BB_SetPw.setValue("");
	BB_SetData.setValue("");
	BB_SetCD.setValue("");
	BB_SetData.clear();
	%cnt=ServerConnection.getCount();
	for(%i=0;%i<%cnt;%i++)
	{
		%obj=serverConnection.getObject(%i);
		if(%obj.getClassName()!$="PlayerData") {continue;}
		if(%obj.uiName$="") {continue;}
		BB_SetData.add(%obj.uiName,%i);
	}
	commandToServer('RequestBoxSetting',$BB_SettingBox,"Name");
	commandToServer('RequestBoxSetting',$BB_SettingBox,"Pw");
	commandToServer('RequestBoxSetting',$BB_SettingBox,"Msg");
	commandToServer('RequestBoxSetting',$BB_SettingBox,"Datablock");
	commandToServer('RequestBoxSetting',$BB_SettingBox,"CD");
}

function BB_ApplySettings()
{
	commandToServer('ApplyBoxSettings',$BB_SettingBox,"Start");
	commandToServer('ApplyBoxSettings',$BB_SettingBox,"Name",BB_SetName.getValue());
	commandToServer('ApplyBoxSettings',$BB_SettingBox,"Pw",BB_SetPw.getValue());
	commandToServer('ApplyBoxSettings',$BB_SettingBox,"Msg",BB_SetMsg.getValue());
	commandToServer('ApplyBoxSettings',$BB_SettingBox,"Datablock",BB_SetData.getValue());
	commandToServer('ApplyBoxSettings',$BB_SettingBox,"CD",BB_SetCD.getValue());
}

function clientCmdBB_ReceiveSet(%set,%val)
{
	switch$(%set)
	{
		case "Name":
			BB_SetName.setValue(%val);
		case "Msg":
			BB_SetMsg.setValue(%val);
		case "Pw":
			BB_SetPw.setValue(%val);
		case "Datablock":
			BB_SetData.setValue(%val);
		case "CD":
			BB_SetCD.setValue(%val);
		default:
			//Nothing
	}
}